﻿using Harmony;
using RimWorld;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using UnityEngine;
using Verse;

namespace SelectableSculptureGraphic {
    public class CompSculpture : ThingComp {
        public int index = -1;

        [DebuggerHidden]
        public override IEnumerable<Gizmo> CompGetGizmosExtra() {
            yield return new Command_Action {
                action = new Action(this.ShowReport),
                defaultLabel = "SelectableSculptureGraphic.CommandSelectGraphic".Translate(),
                defaultDesc = "SelectableSculptureGraphic.CommandSelectGraphicDesc".Translate(),
                icon = ContentFinder<Texture2D>.Get("Things/Building/Art/Sculpturesmall/SculptureSmallAbstractA", true)
            };
        }

        private void ShowReport() {
            Graphic_Random graphic = parent.Graphic as Graphic_Random;
            if (graphic != null) {
                Graphic[] graphics = Traverse.Create(graphic).Field("subGraphics").GetValue<Graphic[]>();
                //index = (index + 1) % graphics.Length;
                //Log.Message("Set " + index);
                List<TextureMenuOption> list = new List<TextureMenuOption>();
                Vector2 drawSize = Vector2.one;
                for (int i = 0; i < graphics.Length; i++) {
                    Texture2D tex = graphics[i].MatSingle.mainTexture as Texture2D;
                    if (tex != null) {
                        list.Add(new TextureMenuOption(tex, (int index) => {
                            this.index = index;
                            //Log.Message("Set " + index);
                            this.parent.Map.mapDrawer.MapMeshDirty(this.parent.Position, MapMeshFlag.Things);
                        }));

                        if (i == 0) {
                            drawSize = graphics[i].drawSize;
                        }
                    }
                }
                Find.WindowStack.Add(new Dialog_SelectTexture(list, drawSize * 64));
            }
        }

        //データを保存
        public override void PostExposeData() {
            base.PostExposeData();
            Scribe_Values.Look<int>(ref this.index, "index", -1);
        }
    }
}
