﻿using Harmony;
using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using UnityEngine;
using Verse;
using Verse.AI;

namespace SelectableSculptureGraphic {
    [StaticConstructorOnStartup]
    class Main {
        static Main() {
            var harmony = HarmonyInstance.Create("com.tammybee.selectablesculpturegraphic");
            harmony.PatchAll(Assembly.GetExecutingAssembly());
        }
    }

    [HarmonyPatch(typeof(Graphic_Random))]
    [HarmonyPatch("SubGraphicFor")]
    public static class Graphic_Random_SubGraphicFor_Patch {
        [HarmonyPrefix]
        static bool SetGraphic(Thing thing, Graphic_Random __instance, ref Graphic __result) {
            ThingWithComps thingWithComps = thing as ThingWithComps;
            if (thingWithComps == null) {
                return true;
            }

            CompSculpture compSculpture = thingWithComps.TryGetComp<CompSculpture>();
            if (compSculpture == null) {
                return true;
            }

            Graphic[] graphics = Traverse.Create(__instance).Field("subGraphics").GetValue<Graphic[]>();
            int index = compSculpture.index;
            if (index < 0) {
                index = thing.thingIDNumber;
            }
            __result = graphics[index % graphics.Length];
            //Log.Message("Graphic:" + compSculpture.index);
            return false;
        }
    }
}
